/************************************************************************
 *                                                                      *
 *    Copyright (c) 1991 Wilhelm Valder, Regine Freitag, Wolfgang Dzida *
 *                        All rights reserved                           *
 *                                                                      *
 *                                                                      *
 *    Permission to copy this program or any part of this program is    *
 *    granted in case of personal, non-commercial use only. Any use     *
 *    for profit or other commercial gain without written permissions   *
 *    of the authors is prohibited.                                     *
 *                                                                      *
 *    You may freely distribute this program to friends, colleagues,    *
 *    etc.  As a courtesy we would appreciate it if you left our names  *
 *    on the code as the authors.                                       *
 *    We also, of course, disavow any liabilities                       *
 *    for any bizarre things you may choose to do with the system.      *
 *                                                                      *
 *    We would appreciate though your letting us know about any         *
 *    extensions, modifications, project suggestions, etc.              *
 *    Please mail all bugs, comments, complaints and suggestions to:    *
 *                                                                      *
 *                                                                      *
 *    GMD (German National Research Center for Computer Science)        *
 *    Institut fuer Systemtechnik (F2G2)                                *
 *    P.O. Box 1240                                                     *
 *    Schloss Birlinghoven                                              *
 *    D-5205 St. Augustin 1, West Germany                               *
 *                                                                      *
 *    email:    dzida@kmx.gmd.dbp.de                                    *
 *              freitag@gmdzi.uunet                                     *
 *                                                                      *
 ************************************************************************/
#include <sys/types.h>
#include<fcntl.h>
#include <sys/param.h>
#include <sys/user.h>
#include <sys/file.h>
#include <kvm.h>

#include "listener.h"

static char SccsID[] = "@(#)getcwd.c	1.2\t11/25/92";            /* sccs keyword */

extern Listener *listener;

/* getCwd ********************************************************************
 * 
 *****************************************************************************/

getCwd(buf, size)
     char *buf;
     int size;
{
  static int spid = 0;
  static kvm_t *kd = NULL;
  struct user *u;
  struct proc *p;
  struct ucwd u_cwd;
  int rc;

  if (spid != listener->application[SHELL].pid) {
    if (kd)
      kvm_close(kd);

    if (! (kd = kvm_open(NULL, NULL, NULL, O_RDONLY, "Cannot open kernel image !")))
      return(False);
    spid = listener->application[SHELL].pid;
  }

  p = kvm_getproc(kd, spid);
  u = kvm_getu(kd, p);
  rc = kvm_read(kd, (unsigned long) u->u_cwd, 
				(char *) &u_cwd, sizeof(struct ucwd));
  rc = kvm_read(kd, (unsigned long) u_cwd.cw_dir, buf, size);

  /*return((*buf) ? True : False);*/
}
