/*****************************************************************************
 * contains include-files, constants, structure definitions and externals of 
 * history tracer
 *****************************************************************************/

/*#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <exBasics.h>
#include <exLayout.h>      in exMenuP.h included */

#include <exMenu.h>
#include <exEdit.h>
#include <exErrors.h>
#include "history.h"

#define H_BORDER        1                /* border size of father window */
#define H_TITLEBORDER   2                /* border size of title window */
#define H_NUMCOL        4                /* number of cols in number editor */
#define H_SCRLBWIDTH	20		 /* width of scrollbar */
#define HISTORY_OPEN    0x1              /* set if history editor is mapped */
#define XICON           1041             /* x-value for icon window */
#define YICON           140              /* y-value for icon window */
#define MAXHIST         100              /* maximum number of commands
					    stored in history tracer */
#define HISTMENUCNT     1                /* number of menus in history tracer */
#define HISTMENUS       "history.menu" 

#define LINEMARK        "  >"      /* marks continuation of command in tracer */
#define START           True
#define END             False

/*
 * structure to describe windows needed for the history editor
 */

typedef struct _historyWindow {
  Widget histShell;                    /* application shell */
  Widget histForm;                     /* form widget containing both
					  editors */
  exMenubar *menuBar;
  Widget scrollbar;
  Editor comEdit;                      /* Widget of command editor */
  Editor numEdit;                      /* Widget of number editor */
  int flag;
} historyWindow;

static EditorDescr HEditDescr = {
  (int (*)()) 0,                        /* input function */
  (char *) 0,                           /* file */
  (char *) 0,	                        /* editor name */
  (char **) 0,                          /* buffer */
  (Window) 0,                           /* message window */
  MAXHIST,    				/* number of lines in buffer */
  0,					/* lines in window */
  0,					/* cols  in window */
  0, 					/* width of window */
  0,					/* height of window */
  ED_HELP,                              /* flags */
};

static EditorDescr numDescr = {
  (int (*)()) 0,                        /* input function */
  (char *) 0,                           /* file */
  (char *) 0,	                        /* editor name */
  (char **) 0,                          /* buffer */
  (Window) 0,                           /* message window */
  MAXHIST,    				/* number of lines in buffer */
  0,					/* lines in window */
  H_NUMCOL,				/* cols  in window */
  0, 					/* width of window */
  0,					/* height of window */
  ED_HELP,                              /* flags */
};

typedef struct _commandStatistics {
  int comSeq[MAXHIST][2];
  int comCount;                /* holds number of commands in history tracer */
  char *complCom;
} commandStatistics;

BufInfo *bufinfoptr();

extern historyWindow *exHistory;
extern commandStatistics *comStat;




 




