/************************************************************************
 *                                                                      *
 *    Copyright (c) 1991 Wilhelm Valder, Regine Freitag, Wolfgang Dzida *
 *                        All rights reserved                           *
 *                                                                      *
 *                                                                      *
 *    Permission to copy this program or any part of this program is    *
 *    granted in case of personal, non-commercial use only. Any use     *
 *    for profit or other commercial gain without written permissions   *
 *    of the authors is prohibited.                                     *
 *                                                                      *
 *    You may freely distribute this program to friends, colleagues,    *
 *    etc.  As a courtesy we would appreciate it if you left our names  *
 *    on the code as the authors.                                       *
 *    We also, of course, disavow any liabilities                       *
 *    for any bizarre things you may choose to do with the system.      *
 *                                                                      *
 *    We would appreciate though your letting us know about any         *
 *    extensions, modifications, project suggestions, etc.              *
 *    Please mail all bugs, comments, complaints and suggestions to:    *
 *                                                                      *
 *                                                                      *
 *    GMD (German National Research Center for Computer Science)        *
 *    Institut fuer Systemtechnik (F2G2)                                *
 *    P.O. Box 1240                                                     *
 *    Schloss Birlinghoven                                              *
 *    D-5205 St. Augustin 1, West Germany                               *
 *                                                                      *
 *    email:    dzida@kmx.gmd.dbp.de                                    *
 *              freitag@gmdzi.uunet                                     *
 *                                                                      *
 ************************************************************************/
#include <X11/Intrinsic.h>
#include "display.h"
#include <exBasics.h>

/* intersect: *****************************************************************
 * intersection between 2 rectangles; returns true if intersection non-empty
 *****************************************************************************/

Boolean intersect(srcp, maxrow, maxcol, dstp)
     RECT *srcp;			/* source rectangle */
     int maxrow;			/* max row of clipping rectangle */
     int maxcol;			/* max column of clipping rectangle */
     RECT *dstp;			/* destination rectangle */
{
  dstp->r1 = MAX(0, srcp->r1);
  dstp->c1 = MAX(0, srcp->c1);
  dstp->r2 = MIN(maxrow, srcp->r2);
  dstp->c2 = MIN(maxcol, srcp->c2);
  return((Boolean)(dstp->r1 <= dstp->r2 && dstp->c1 <= dstp->c2));
}

RECT GIANT_RECT = {0, 0, GIANT, GIANT};


