#ifndef _ex_exMenu_h_
#define _ex_exMenu_h_

#include <exMenuP.h>

extern Atom exMenuReturnValue;

/***************************************************************************
 *
 *		EXTERNAL FUNCTION DECLARATIONS 
 *
 ***************************************************************************/

extern ApplicationNode *createApplNode();
extern ApplicationNode *currentApplication();
extern ApplicationNode *getApplByName(/* name */);
extern Boolean Access(/* aptr, access */);
extern Boolean Cnttype(/* Cnttpe */);
extern Boolean MenusToSave(/* aptr */);
extern Boolean Mtyp(/* mtyp */);
extern Boolean checkEvent(/* event */);
extern Boolean checkFunc(/* aptr */);
extern Boolean checkMenuConsistency(/* mptr */);
extern Boolean cmpItemDescr(/* iptr1, iptr2 */);
extern Boolean cmpMenuDescr(/* mptr1, mptr2 */);
extern Boolean cmpReqDescr(/* req1, req2 */);
extern Boolean colorType(/* ctype */);
extern Boolean deleteItem(/* m,item */);
extern Boolean deleteMenu(/* aptr, m */);
extern Boolean deleteWorkMenu(/* m */);
extern Boolean dumpToFile(/* w */);
extern Boolean exCallMenu(/* m */);
extern Boolean exCallPanel(/* m, x, y */);
extern Boolean exCreatePopupMenuRepr(/* parent, m */);
extern Boolean exCreatePulldownMenuRepr(/* menubar, m */);
extern Boolean exHidePanel(/* m */);
extern Boolean initMenus(/* mbar, parent, file, menus, mcnt */);
extern Boolean isItemActive(/* mptr, icnt */);
extern Boolean isItemKey(/* item,key */);
extern Boolean isPopup(/* mptr */);
extern Boolean isPulldown(/* mptr */);
extern Boolean legalAccess(/* acc */);
extern Boolean legalType(/* type,value */);
extern Boolean loadCurrentApplication(/* mbar, parent, menus, mcnt */);
extern Boolean loadMenuDir(/* parent, menupath */);
extern Boolean loadMenus(/* mbar, parent, aptr, menus, mcnt */);
extern Boolean reprType(/* rtype */);
extern Boolean resetMDS();
extern Boolean restoreFromFile(/* w, file, forced */);
extern Boolean setItemName(/* m, slot, name */);
extern MHiRepr *new_iRepr(/* name, key */);
extern MHiReq *makeOneRequest(/* fnct, data, initialValue, size */);
extern MHiReq *newRequest();
extern MHiRet *newRetPattern(/* pattern */);
extern MHitem *createItem();
extern MHitem *getItemByKey(/* mptr,key */);
extern MHitem *makeOneItem(/* mptr, name, key, retPattern, requests */);
extern MHitem *newItem(/* mptr,name,key */);
extern MHmenu *buildMenuFromStrings(/* name, type, itemList, returnList, cnt */);
extern MHmenu *createMenu();
extern MHmenu *getMenuDescrByName(/* name */);
extern MHmenu *makeOneMenu(/* name, selCnt, selType, x, y, posType */);
extern MHmenu *newMenu(/* name */);
extern buildMenuList(/* aptr, mlist */);
extern char *GetNameFromFile(/* file */);
extern char *exGetMenuReturnValue(/* m */);
extern char *getMenuEventReturnValue(/* event */);
extern char *getMenuPath(/* aptr */);
extern checkRequests(/* iptr */);
extern clearApplNode(/* indx */);
extern clearItem(/* item */);
extern clearMenu(/* mptr */);
extern copyItemDescr(/* from,to */);
extern copyMenuDescr(/* from,to */);
extern copyRequestDescr(/* from, to */);
extern countCondition(/* cond, first, second */);
extern countRequestsInPattern(/* pattern */);
extern deleteApplNode(/* aptr */);
extern deleteFunction(/* aptr, func */);
extern deleteRequest(/* iptr,rcnt */);
extern dsplInWnd(/* parms */);
extern dumpHlp(/* fd, aptr, hlp */);
extern dumpReq(/* fd, aptr, rptr */);
extern dumpRequests(/* fd, aptr, requests */);
extern dumpRet(/* fd,rptr */);
extern dumpUserFuncs(/* fd, aptr */);
extern dump_iRepr(/* fd,repr */);
extern dump_mRepr(/* fd,m_repr */);
extern exCreatePanelRepr(/* parent, m, cols, width */);
extern exMenu *exCreateMenuStruct(/* aptr, mptr */);
extern exMenu *exMakeMenu(/* aptr, menubar, parent, mptr */);
extern exMenu *exMakePanel(/* aptr, parent, mptr, cols, width, forceScrollbar */);
extern exMenu *getMenuByName(/* name, menusArray, menuNo */);
extern exMenubar *createMenuBar(/* parent, mb_args, mb_cnt, getReturnValue */);
extern exMenubar *exCreateMenuBar(/* parent, mb_args, mb_cnt, getReturnValue */);
extern exPopdown(/* w */);
extern getApplIdentifier(/* path, applList, length */);
extern getCol(/* m, x */);
extern getCurAppl();
extern getFuncByName(/* aptr, name */);
extern getMDSindex(/* aptr */);
extern getRow(/* m, y */);
extern getiPos(/* iptr,x,y,t */);
extern getmPos(/* mptr,x,y */);
extern initApplNode(/* aptr, name */);
extern initItem(/* iptr, name, key */);
extern initMDS();
extern initMDSarray();
extern initMenu(/* mptr, type, name */);
extern insertActMasks(/* mptr,am */);
extern insertFunction(/* aptr, func, funcName */);
extern insertItem(/* m,item,where */);
extern insertMenu(/* m */);
extern insertRequest(/* iptr, req, rcnt */);
extern insertReturnValues(/* iptr, pattern, buffer, returnbuffer */);
extern int callRequestFunction(/* m, f, parms */);
extern int countTokens(/* str */);
extern int insertApplNode(/* ptr */);
extern int newApplicationNode(/* name */);
extern mds_function(/* fnct */);
extern menuBarHeight(/* mb */);
extern removeApplNode(/* aptr */);
extern reqViaForm(/* parms */);
extern reqViaMenu(/* parms */);
extern reqViaWnd(/* parms */);
extern resetDefaultItem(/* iptr */);
extern restoreHlp(/* fd,aptr,hlp */);
extern restorePos(/* fd,pos */);
extern restoreReq(/* fd, aptr, rptr */);
extern restoreRequests(/* fd, aptr, requests */);
extern restoreRet(/* fd,rptr */);
extern restoreStringList(/* fd,sptr,max */);
extern restoreUserFuncs(/* fd, aptr */);
extern restore_iRepr(/* fd,repr */);
extern restore_mRepr(/* fd,repr */);
extern setAccess(/* aptr, access */);
extern setCurrentApplication(/* aptr */);
extern setDefaultItem(/* iptr */);
extern setFile(/* aptr,string */);
extern setInitialMask(/* m, am */);
extern setItemActivityMask(/* mptr, iptr, actVal */);
extern setItemKey(/* iptr, key */);
extern setMaxItem(/* mptr, cnt */);
extern setMenuActivityMask(/* mptr,iptr */);
extern setMenuCoordinates(/* mptr, x, y */);
extern setMenuFlag(/* mptr, flags */);
extern setMenuInitialActivityMask(/* mptr, actVal */);
extern setMenuPos(/* mptr, x, y, posType */);
extern setMenuPosType(/* mptr, posType */);
extern setMenuRepresentation(/* mptr,name,rtype */);
extern setMenuType(/* mptr, type */);
extern setReqCnt(/* req, cnt, type */);
extern setReqFnct(/* req, fnct */);
extern setReqSize(/* req, size */);
extern setRequestData(/* req, data */);
extern setRequestInitialValue(/* req, initialValue */);
extern setRetPattern(/* iptr,ret */);
extern setSelCnt(/* mptr,cnt */);
extern setSelType(/* mptr, type */);
extern setToggle(/* iptr, onoff */);
extern setToggleItem(/* iptr, onoff */);
extern setWorkApplication();
extern user_function(/* fnct, aptr */);
extern void _exInitMenus(/* d */);
extern void announceIllegalMenuCount(/* m, csr */);
extern void announceIllegalTokenCount(/* m, parent, type, cnt, actCnt */);
extern void checkMenuActivityMask(/* m, display */);
extern void displayItem(/* m, slot, sel */);
extern void exGrabMenu(/* m, csr */);
extern void exInitMenus(/* d */);
extern void exMakeDefaultMenu(/* m */);
extern void freeMenu(/* m */);
extern void postMenu(/* m */);
extern void postPanel(/* m, x, y */);
extern void setMenuActive(/* m, active */);
extern whichFunction(/* aptr, fnct */);
#endif
