static switchBuffer();
static saveFK();
static writeFK();
static findFK();
static insertFK();

/******************************************************************************
 * contains command tables for the function key editor
 *****************************************************************************/

static editCmd CmdTable [] = { 		/* define standard command set */
  {ctrl('a'), beglin}, 		   	/* beginning of line */
  {ctrl('b'), left}, 		        /* cursor left  */
  {ctrl('d'), delnxt},	        	/* delete next character */
  {ctrl('e'), endlin},   		/* end of line */
  {ctrl('f'), right}, 		        /* cursor right */
  {ctrl('j'), newline},                 /* split line */
  {ctrl('k'), krest},			/* delete to end of line */
  {ctrl('l'), newscr},   		/* redraw screen */
  {ctrl('m'), newline},                 /* split line */
  {ctrl('n'), dwncol}, 		    	/* down in column */
  {ctrl('o'), openln},	  		/* open line above */
  {ctrl('p'), upcol}, 		    	/* up in column */
  {ctrl('r'), bwsearch},		/* search backward */
  {ctrl('s'), fsearch},			/* search forward */
  {ctrl('v'), dwnpage},   		/* forward page */
  {127,     delprev},   		/* delete previous char */
  {EOS,     (int (*)()) 0},		/* end of list */
};		

static editCmd ctrlXCmds [] = {		       
  {ctrl('i'), insertFK},		/* insert function key */
  {ctrl('o'), switchBuffer},		/* switch to next buffer */
  {'k', killBuffer},			/* clear the current buffer */
  {'l', findFK},			/* read in function key */
  {'o', switchBuffer},			/* switch to next buffer */
  {'s', saveFK},			/* save current function key */
  {'t', lineToTop},			/* current line to top of screen */
  {'w', writeFK},			/* write curent function key */
  {'?', help},				/* display help information */
  {EOS, (int (*)()) 0},		
};

static editCmd EscCmds [] = {
  {'<', topBuffer},			/* goto top of file */
  {'>', botBuffer},			/* goto bottom of file */
  {' ', goLine},			/* goto specified line */
  {'=', memory},			/* display statistics */
  {'b', wordl},				/* move to left word */
  {'d', fdelword},			/* delete next word */
  {'f', wordr},				/* move to right word */
  {'h', topscr},			/* cursor to top of display */
  {'l', botscr},			/* cursor to last line of display */
  {'m', midscr},			/* cursor near middle of display */
  {'n', upScroll},			/* scroll up */
  {'p', dwnScroll},			/* scroll down */
  {'r', bbsearch},			/* continue search backword */
  {'s', ffsearch},			/* continue search forward */
  {'v', uppage},			/* display previous page */
  {'w', wordr},				/* delete next word */
  {127, bdelword},			/* delete previous word */
  {EOS, (int (*)()) 0},		
};

static cmdDescr fkmCmds[] = {
  {switchBuffer, "   Switch the cursor between the editors."},
  {saveFK,       "   Save the current function key."},
  {writeFK,	 "   Save the current function key with a new name."},
  {findFK,	 "   Load a function key from the current function key set."},
  {insertFK,	 "   Insert a file in the function key body."}
};
